<?php
function get_ext($filename) {
	$p = strrpos($filename,".");
	if ($p===false) return "file";
	
	return strtolower(substr($filename,$p+1));
}

function get_file_type($filename) {
	$ext = get_ext($filename);
		
	switch($ext) {
		case 'rpm':
		case 'zip':
		case 'gz':
		case 'tar':
		case 'rar':
			$x = 'archive';
			break;
		case 'pdf':
			$x = 'pdf';
			break;
		case 'html':
		case 'htm':
			$x = 'html';
			break;
		case 'jpg':
		case 'jpeg':
		case 'gif':
		case 'jfif':
		case 'png':
		case 'bmp':
		case 'psd':
		case 'eps':
		case 'svg':
			$x = 'image';
			break;
		case 'log':
			$x = 'log';
			break;
		case 'mov':
			$x = 'quicktime';
			break;
		case 'rm':
		case 'ra':
		case 'ram':
			$x = 'real';
			break;
		case 'avi':
		case 'mpg':
		case 'mpeg':
		case 'wmv':
			$x = 'video';
			break;
		case 'mp3':
		case 'wav':
		case 'wma':
		case 'ogg':
			$x = 'sound';
			break;
		case 'txt':
		case 'doc':
			$x = 'text';
			break;
		case 'xls':
		case 'csv':
			$x = 'spreadsheet';
			break;
		case 'bin':
		case 'cue':
		case 'iso':
			$x = 'iso';
			break;
		case 'exe':
		case 'com':
		case 'bat':
			$x = 'executable';
			break;
		default:
			$x = 'file';
	}
	
	return $x;
}


function get_file_mimetype($filename) {
	
	if (function_exists('mime_content_type')) {
		return mime_content_type($filename);
	} else {
		$p = strrpos($filename,".");
		if ($p===false) return "file";
		
		$ext = strtolower(substr($filename,$p+1));
			
		switch($ext) {
			case 'zip': $x = 'application/zip'; break;
			case 'gz': $x = 'application/x-gzip'; break;
			case 'tar': $x = 'application/x-tar'; break;
			case 'pdf': $x = 'application/pdf'; break;
			case 'html':
			case 'htm':
				$x = 'text/html';
				break;
			case 'jpg':
			case 'jpeg':
			case 'jfif':
				$x = 'image/jpeg';
				break;
			case 'gif': $x = 'image/gif'; break;
			case 'png': $x = 'image/png'; break;
			case 'bmp': $x = 'image/bmp'; break;
			case 'eps': $x = 'application/postscript'; break;
			case 'log': $x = 'text/plain'; break;
			case 'avi': $x = 'video/x-msvideo'; break;
			case 'rm':
			case 'ram':
				$x = 'audio/x-pn-realaudio';
				break;
			case 'ra': $x = 'audio/x-realaudio'; break;
			case 'mpg':
			case 'mpeg':
				$x = 'video/mpeg';
				break;
			case 'mov': $x = 'video/quicktime'; break;
			case 'mp3': $x = 'audio/mpeg'; break;
			case 'wav': $x = 'audio/x-wav'; break;
			case 'txt': $x = 'text/plain'; break;
			case 'doc': $x = 'application/msword'; break;
			case 'xls': 
			case 'csv':
				$x = 'application/vnd.ms-excel';
				break;
			default:
				$x = 'application/octet-stream';
		}
		return $x;
	}
}


function get_human_size($target) {
	if (is_integer($target)) {
		$size = $target;
	} else {
		$size = filesize($target);
	}
	if ($size>1024*1024*1024) {
		return round($size/1024/1024/1024,2)."GB";
	} elseif ($size>1024*1024) {
		return round($size/1024/1024,2)."MB";
	} elseif ($size>1024) {
		return round($size/1024,2)."KB";
	} else {
		return $size." Bytes";
	}
}

require_once("config.php");
require_once("directemplate/class_Template.php");
$tpl = &new Template();
$tpl->template_dir = dirname(__FILE__)."/templates/";
?>