<?php
require_once("include.php");

function safestring($s) {
	return str_replace(
		array("\"",		"\n","\r"),
		array("&quot;", "<br />",""),
		$s
	);
}

function output_result($res) {
	$output = "";
	foreach ($res as $k=>$v) $output .= "\"".safestring($v,ENT_COMPAT)."\",";

	$output = "[ " . substr($output,0,strlen($output)-1) . " ]";
	echo "<html><script language='javascript'>values = {$output}; top.show_tooltip(values)</script></html>";
	
	die;
}

// format:
// result|filename|filesize|image|details

$info = array(
	'result'=>'',
	'filename'=>'',
	'filesize'=>'',
	'image'=>'',
	'details'=>'',
);


if (!$_REQUEST['file']) { $info['result'] = 'No filename specified'; output_result($info); }

$basepath = realpath(FILE_PATH);
$filepath = realpath(FILE_PATH.urldecode($_REQUEST['file']));
if (substr($filepath,0,strlen($basepath))!=$basepath) { $info['result'] = 'Invalid filename: ['.$filepath.']'; output_result($info); }

if (!is_readable($filepath)) { $info['result'] = 'Cannot access file'; output_result($info); }

$type = get_file_type($filepath);
$ext = get_ext($filepath);

$info['result'] = 'OK';
$info['filename'] = basename($filepath);
if (is_dir($filepath)) {
	$info['filesize'] = 'Directory';
} else {
	$info['filesize'] = get_human_size($filepath);
}
$info['image'] = 'images/mimetypes/'.$type.'.png';

switch($type) {
	case 'image':
		list($width, $height, $type, $attr) = @getimagesize($filepath);
		$info['details'] = "{$width}x{$height} ".strtoupper($ext)." image";
		$info['image'] = "index.php?thumb=".$_REQUEST['file']."&width=50&height=50&allowed=75";
		break;
	default:
	
		break;
}
switch($ext) {
	case 'txt':
		$fp = @fopen($filepath,"r");
		if ($fp) {
			$firstline = fread($fp,128);
			fclose($fp);
			$firstline = str_replace(array("\r","\n")," ",$firstline);
			$info['details'] = trim($firstline)."...";
		}
		break;
	case 'mp3':
		require_once(dirname(__FILE__)."/class_ID3.php");
		$id3 = &new ID3($filepath);
		$info['details'] = 
			($id3->name?"Title: ".$id3->name."<br />":"").
			($id3->artist?"Artist: ".$id3->artist."<br />":"").
			($id3->album?"Album: ".$id3->album."<br />":"").
			($id3->lengths?"Length: ".$id3->lengths."s<br />":"");
		
		
		break;
	case 'zip':
		$cmd = 'unzip -l '.escapeshellarg($filepath);
		$res = `$cmd`;
		$res = explode("\n",trim($res));
		$totals = trim(array_pop($res));
		if (preg_match("/([0-9]+)\s*([0-9]+)/i",$totals,$matches)) {
			list(,$size,$files) = $matches;
			$size = (int) $size;
			$info['details'] = "$files file(s), ".get_human_size($size)." uncompressed";
		}
		break;
}

output_result($info);
?>